<?php

namespace plugin\inspection\controller\api\auth;

use plugin\inspection\controller\api\Auth;
use plugin\inspection\model\InspectionRecord;
use plugin\ticket\model\TicketTicket;

class Record extends Auth
{
    public function index()
    {
        $pageData = $this->staff->records()->with(['points'])->order('create_at desc')->paginate();
        $this->success('获取记录成功', $pageData);
    }

    public function create()
    {
        $this->staff->records()->save([
            'staff_id' => $this->staff->id,
            'create_at' => date('Y-m-d H:i:s'),
            'status' => 0,
        ]);
        $this->success('创建记录成功');
    }

    public function end()
    {
        $record_id = $this->request->post('record_id');
        $record = InspectionRecord::mk()->where('id', $record_id)->find();
        if (empty($record)) {
            $this->error('记录不存在');
        }
        $lat = $this->request->post('lat');
        $lng = $this->request->post('lng');
        $imgs = $this->request->post('imgs');
        $content = $this->request->post('content');
        $record->status = 1;
        $record->imgs = $imgs;
        $record->content = $content;
        $record->points()->save([
            'lat' => $lat,
            'lng' => $lng,
            'create_at' => date('Y-m-d H:i:s'),
        ]);
        $record->save();
        $this->success('结束记录成功');
    }

    public function add_point()
    {
        $record_id = $this->request->post('record_id');
        $lat = $this->request->post('lat');
        $lng = $this->request->post('lng');
        /** @var InspectionRecord $record */
        $record = InspectionRecord::mk()->where('id', $record_id)->find();
        if (empty($record)) {
            $this->error('记录不存在');
        }
        $record->points()->save([
            'lat' => $lat,
            'lng' => $lng,
            'create_at' => date('Y-m-d H:i:s'),
        ]);
        $record->distance = $record->calculateDistance();
        $record->save();
        $this->success('添加点成功');
    }

}