<?php

namespace plugin\inspection\controller\api\auth;

use plugin\inspection\controller\api\Auth;
use plugin\inspection\model\InspectionRecord;
use plugin\ticket\model\TicketTicket;

class Ticket extends Auth
{
    public function add()
    {
        $record_id = $this->request->post('record_id');
        $record = null;
        if (!empty($record_id)) {
            /** @var InspectionRecord $record */
            $record = InspectionRecord::mk()->where('id', $record_id)->find();
            if (empty($record)) {
                $this->error('记录不存在');
            }
        }
        $lat = $this->request->post('lat');
        $lng = $this->request->post('lng');
        $type_id = $this->request->post('type_id');
        $title = $this->request->post('title');
        $content = $this->request->post('content');
        $ticket_region = $this->request->post('ticket_region');
        $ticket_address = $this->request->post('ticket_address');
        $imgs = $this->request->post('imgs');
        $ticket_project_use = $this->request->post('ticket_project_use');
        $ticket_work_use = $this->request->post('ticket_work_use');
        $ticket_price =$this->request->post('ticket_price');
        $data = [
            'uid' => $this->staff->id,
            'utype' => $this->staff->id,
            'type_id' => $type_id,
            'title' => $title,
            'content' => $content,
            'contact_name' => $this->staff->name,
            'contact_phone' => $this->staff->phone,
            'ticket_region' => $ticket_region,
            'ticket_address' => $ticket_address,
            'lat' => $lat,
            'lng' => $lng,
            'imgs' => $imgs,
            'ticket_project_use' =>$ticket_project_use,
            'ticket_work_use' => $ticket_work_use,
            'ticket_price' => $ticket_price,
        ];
        if (!empty($record)) {
            $record->ticket()->create($data);
        } else {
            TicketTicket::create($data);
        }
        $this->success("工单创建成功");
    }
}