<?php

namespace plugin\ticket\controller;

use plugin\ticket\model\TicketTicket;
use plugin\ticket\model\TicketType;
use think\admin\Controller;
use think\admin\helper\QueryHelper;

/**
 * 工单类型管理
 */
class Type extends Controller
{
    /**
     * 工单类型列表
     * @return void
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     */
    public function index()
    {
        $this->title = '工单类型';
        TicketType::mQuery()->layTable(function () {

        }, function (QueryHelper $query) {
            $query->withCount(['tickets']);
            $query->like(['name'])->equal(['status']);
        });
    }

    /**
     * 添加工单类型
     * @return void
     */
    public function add()
    {
        $this->title = '添加工单类型';
        TicketType::mForm('form');
    }

    /**
     * 编辑工单类型
     * @return void
     */
    public function edit()
    {
        $this->title = '编辑工单类型';
        TicketType::mForm('form');
    }

    /**
     * 修改工单类型状态
     * @return void
     */
    public function status()
    {
        TicketType::mSave($this->_vali([
            'id.require' => '类型ID不能为空',
            'status.in:0,1' => '状态值范围异常！',
            'status.require' => '状态值不能为空！',
        ]), 'id');
    }

    /**
     * 修改工单类型排序
     * @return void
     */
    public function sort()
    {
        TicketType::mSave($this->_vali([
            'id.require' => '文章ID不能为空',
            'sort.require' => '排序值不能为空！',
            'sort.number' => '排序必须为数字！',
            'sort.between:0,9999' => '排序值必须为0~9999之间！',
        ]), 'id');
    }
    /**
     * 删除工单类型
     * @return void
     */
    public function remove()
    {
        ['id' => $id] = $this->_vali(['id.require' => '请指定工单类型ID！']);
        $count = TicketTicket::mk()->scope('avail')->where('type_id', '=', $id)->count();
        if ($count > 0) {
            $this->error('工单类型删除失败，请先删除该类型下的工单！');
        }
        TicketType::mDelete();
    }
}